
/*
 * tr2port.h
 *
 * portability header for TR2 viewer/editor project
 */
#ifndef TR2PORT_H // prevent accidental double-inclusion
#define TR2PORT_H

/*
 * PC/Mac definition
 *
 * #define INTELPC for Intel Win9X PCs
 * #define MACINTOSHPC for Macintosh PCs
 *
 * Only #define one of them, please!
 */
#define  INTELPC
#undef   MACINTOSHPC

/* make sure only one of INTELPC or MACINTOSHPC is #defined */
#ifdef INTELPC
#ifdef MACINTOSHPC
#error "Can't define both INTELPC and MACINTOSHPC"
#endif
#endif
#ifndef INTELPC
#ifndef MACINTOSHPC
#error "Must define either INTELPC or MACINTOSHPC"
#endif
#endif

#ifdef INTELPC
// argument to fopen() to indicate "binary read"
#define  READBINARY   "rb"
// argument to fopen() to indicate "binary write"
#define  WRITEBINARY  "wb"
// argument to fopen() to indicate "ASCII write"
#define  WRITETEXT    "w"
#define  LITTLE_ENDIAN_CPU    // indicate that this is an Intel processor
#undef   BIG_ENDIAN_CPU

#else // MACINTOSHPC

// argument to fopen() to indicate "binary read"
#define  READBINARY   "rb"
// argument to fopen() to indicate "binary write"
#define  WRITEBINARY  "wb"
// argument to fopen() to indicate "ASCII write"
#define  WRITETEXT    "w"
#define  BIG_ENDIAN_CPU       // indicate that this is a Motorola processor
#undef   LITTLE_ENDIAN_CPU
#endif

/*
 * Data Types
 */
#ifdef INTELPC
typedef signed   char      bit8;    // 8-bit,  signed
typedef signed   short int bit16;   // 16-bit, signed
typedef signed   long int  bit32;   // 32-bit, signed

typedef unsigned char      bitu8;   // 8-bit,  unsigned
typedef unsigned short int bitu16;  // 16-bit, unsigned
typedef unsigned long int  bitu32;  // 32-bit, unsigned

#ifndef __cplusplus
typedef unsigned char      bool;    // boolean
#endif
#else // MACINTOSHPC
typedef signed   char      bit8;    // 8-bit,  signed
typedef signed   short int bit16;   // 16-bit, signed
typedef signed   long int  bit32;   // 32-bit, signed

typedef unsigned char      bitu8;   // 8-bit,  unsigned
typedef unsigned short int bitu16;  // 16-bit, unsigned
typedef unsigned long int  bitu32;  // 32-bit, unsigned

#ifndef __cplusplus
typedef unsigned char      bool;    // boolean
#endif

#endif
#endif

